/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entities;

import java.io.Serializable;
import java.util.jar.Attributes.Name;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author hardebolle
 */
@XmlRootElement
public class Conge implements Serializable {
    private static final long serialVersionUID = 1L;
    
    @NotNull(message = "L'identifiant est obligatoire.")
    @Size(min = 1, max = 255, message = "L'identifiant est obligatoire.")
    private String id;
    
    @NotNull(message = "Le nom est obligatoire.")
    @Size(min = 1, max = 255, message = "Le nom est obligatoire.")
    private String nom;

    @NotNull(message = "Le prénom est obligatoire.")
    @Size(min = 1, max = 255, message = "Le prénom est obligatoire.")
    private String prenom;
    
    @Min(value = 0, message = "Le solde de CP ne peut pas être négatif.")
    @Max(value = 25, message = "Le solde de CP ne peut pas être supérieur à 25.")
    private Integer cp;

    @Min(value = 0, message = "Le solde de RTT ne peut pas être négatif.")
    @Max(value = 10, message = "Le solde de RTT ne peut pas être supérieur à 10.")
    private Integer rtt;

    public Conge() {
        this.cp = 25;
        this.rtt = 10;
    }

    public Conge(String id) {
        this();
        this.id = id;
    }

    public Conge(String id, String nom, String prenom) {
        this();
        this.id = id;
        this.nom = nom;
        this.prenom = prenom;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public String getPrenom() {
        return prenom;
    }

    public void setPrenom(String prenom) {
        this.prenom = prenom;
    }

    public Integer getCp() {
        return cp;
    }

    public void setCp(Integer cp) {
        this.cp = cp;
    }

    public Integer getRtt() {
        return rtt;
    }

    public void setRtt(Integer rtt) {
        this.rtt = rtt;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Conge)) {
            return false;
        }
        Conge other = (Conge) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "conges.Conges[ id=" + id + " ]";
    }
    
}
