/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package service;

import business.CongesSingleton;
import exceptions.CongeNotFoundException;
import exceptions.CongeNotValidException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.ejb.Stateless;

/**
 *
 * @author hardebolle
 */
@WebService(serviceName = "CongesService")
@Stateless()
public class CongesService {

    @EJB
    private CongesSingleton singleton;
    
    @WebMethod(operationName = "consulterSoldeRTT")
    public Integer consulterSoldeRTT(@WebParam(name = "identifiant") String identifiant) throws CongeNotFoundException{
        Logger.getLogger("CongesServiceClientInfo").log(Level.INFO, "*** Been asked soldeRTTCourant.");
        return singleton.getSoldeRtt(identifiant);
    }

    @WebMethod(operationName = "consommerRTT")
    public void consommerRTT(@WebParam(name = "identifiant") String identifiant, @WebParam(name = "nbJours") Integer nbJours) throws CongeNotFoundException, CongeNotValidException{
        Logger.getLogger("CongesServiceClientInfo").log(Level.INFO, "*** Been asked decreaseSoldeRTT.");
        //si le nombre de jours a consommer est supérieur au solde, une exception CongeNotValidException sera jetée
        singleton.setSoldeRtt(identifiant, singleton.getSoldeRtt(identifiant)-nbJours);
    }

}
