/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package viewcontroller;

import entities.Conge;
import business.CongesSingleton;
import exceptions.CongeAlreadyExistingException;
import exceptions.CongeNotFoundException;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

/**
 *
 * @author hardebolle
 */
@ManagedBean(name = "congesController")
@SessionScoped
public class CongesController implements Serializable {

    @EJB
    private CongesSingleton facade;
    private Conge courant;

    public List<Conge> getListeConges() {
        return this.facade.getListeConges();
    }

    public Conge getCourant() {
        return this.courant;
    }

    public void setCourant(Conge courant) {
        this.courant = courant;
    }

    public String modifierCourant() {
        FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Le compte a bien été modifié.", "Le compte a bien été modifié.");
        FacesContext.getCurrentInstance().addMessage("congesController", facesMsg);
        return "lister";
    }

    public String supprimerCourant() {
        try {
            this.facade.removeConges(courant.getId());
        } catch (CongeNotFoundException ex) {
            Logger.getLogger(CongesController.class.getName()).log(Level.SEVERE, null, ex);
            FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_ERROR, ex.getMessage(), ex.getMessage());
            FacesContext.getCurrentInstance().addMessage("congesController", facesMsg);
            return "lister";
        }
        FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Le compte a bien été supprimé.", "Le compte a bien été supprimé.");
        FacesContext.getCurrentInstance().addMessage("congesController", facesMsg);
        return "lister";
    }

    public String creerCourant() {
        this.courant = new Conge();
        return "creer";
    }

    public String ajouterCourant() {
        try {
            this.facade.addConges(courant);
        } catch (CongeAlreadyExistingException ex) {
            Logger.getLogger(CongesController.class.getName()).log(Level.SEVERE, null, ex);
            FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_ERROR, ex.getMessage(), ex.getMessage());
            FacesContext.getCurrentInstance().addMessage("congesController", facesMsg);
            return "creer";
        }
        FacesMessage facesMsg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Le compte a bien été ajouté.", "Le compte a bien été ajouté.");
        FacesContext.getCurrentInstance().addMessage("congesController", facesMsg);
        return "lister";
    }
}
